# Installation

## Cloning the repository

The project can be cloned with the command:
`git clone https://git.scc.kit.edu/virtmat-tools/vre-language`.
Alternatively it can be downloaded directly from the [project's  GitLab webpage](https://git.scc.kit.edu/virtmat-tools/vre-language).


## IMPORTANT: Python version requirements
It is strongly recommended to install this project using Python version 3.8 or higher.
This ensures support for all required packages and dependencies.

## Installation using `pip`

The project can be installed in developer mode, into a desired Python virtual environment, using the `pip` package manager.
This is achieved by following these steps:

1. Activate your Python virtual environment accordingly.
2. Make sure you have the latest version of pip for your python installation
    ```
    python -m pip install --upgrade pip
    ```
3. Install packages and dependencies into the environment
    ```
    python -m pip install -e <path_to_folder_containing_setup.cfg>[test]
    ```

## Installation using `conda`

Users employing the **Anaconda** or **Miniconda** Python distributions can use the `conda` package manager to set up the virtual environment required to run the VRE-language.

The provided `conda-setup.yml` file allows the installation of the VRE-language in **developer-mode**. 
The developer installation includes a set of packages for testing developer-specific features of the vre-language.

The set up of the vre-language python environment can be completed by running the setup/installation command:
```
conda env create -f conda-setup.yml
```
This method also takes care of using the required version of the Python interpreter (3.8 or higher).

Once the set up is complete, the environment can be activated by entering:

```
conda activate vre-language
```
