"""
check for duplicated initializations
"""
from textx import get_children_of_type
from textx import get_location
from textx.exceptions import TextXError


def check_duplicates_processor(model, _):
    """
    processor to detect all duplicate object initializations
    """
    names = ['Variable', 'FunctionDefinition', 'ObjectImport']
    objs = []
    for name in names:
        objs.extend(get_children_of_type(name, model))
    seen = set()
    dobjs = [v for v in objs if v.name in seen or seen.add(v.name)]
    if len(dobjs) != 0:
        err_type = 'Initialization error'
        message = f'Repeated initialization of {dobjs[0].name}'
        raise TextXError(message, **get_location(dobjs[0]), err_type=err_type)
