"""utility functions for work with nested lists"""


def list_apply(func, obj):
    """apply a function to all elements of an arbitrarily nested list"""
    if isinstance(obj, list):
        return [list_apply(func, x) for x in obj]
    return func(obj)


def list_flatten(lst):
    """get a flat list out from an arbitrarily nested list"""
    def flatten(lst):
        for elem in lst:
            if isinstance(elem, (list, tuple)):
                for j in flatten(elem):
                    yield j
            else:
                yield elem
    return list(flatten(lst))
